"""
Chainer code (version 1.23.0) for DCNN saliency map model
This code is for testing the well-trained and naively trained model.
"""

from CNN_pilot import CNN
from chainer import cuda, serializers
import test_functions as tf
import os
import sys
from saliency import SalientResult
import six.moves.cPickle as pickle

salBO = []
cuda.init(0)

print 'load image and saliency data'
data = []
gt = []
object_dir = os.listdir("../Toront/")
object_dir.sort()
gt_dir = os.listdir("../TorontGT/")
gt_dir.sort()

# Loading the Toronto dataset filenames.
for i in object_dir:
    if os.path.isfile("../Toront/"+i):
        data.append(i)
for i in gt_dir:
    if os.path.isfile("../TorontGT/"+i):
        gt.append(i)

for i in data:
    print i

cnn = CNN(data=data,gpu=0)
serializers.load_npz('./Model/Model2/ModelEpoch250',cnn.model)#Loading the trained model
cnn.model.to_gpu()

result = cnn.test(data,gt,'../Toront/','../TorontGT/',batchsize=1) #Testing the trained model with Toront dataset

for i in range(0,len(result)):
    salBO.append(SalientResult(result[i].imgname))
    salBO[i].data = result[i].data

pickle.dump(salBO, open("./salWOUrabe_Test.data", 'wb'), -1)#recording the computed saliency maps
